﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace PotterDATExtract
{
	static class Program
	{
		static void Main(string[] args)
		{
			string filename;
			if (args.Length > 0)
				filename = args[0];
			else
			{
				Console.Write("File: ");
				filename = Console.ReadLine();
			}
			using (FileStream dirstr = File.OpenRead(Path.ChangeExtension(filename, "DIR")))
			using (BinaryReader dirreader = new BinaryReader(dirstr))
			{
				int count = dirreader.ReadInt32();
				Console.WriteLine("Found {0} files.", count);
				using (FileStream datstr = File.OpenRead(filename))
				using (BinaryReader datreader = new BinaryReader(datstr))
					for (int i = 0; i < count; i++)
					{
						byte[] buf = dirreader.ReadBytes(12);
						int c = 0;
						while (c < 12 && buf[c] != 0)
							c++;
						string name = Encoding.ASCII.GetString(buf, 0, c);
						int length = dirreader.ReadInt32();
						uint offset = dirreader.ReadUInt32();
						Console.WriteLine("{0}: \"{1}\" Offset: 0x{2:X8} Length: 0x{3:X8}", i + 1, name, offset, length);
						datstr.Seek(offset, SeekOrigin.Begin);
						File.WriteAllBytes(name, datreader.ReadBytes(length));
					}
			}
		}
	}
}