﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace ConsoleApplication1
{
	static class Program
	{
		const int width = 512;
		const int height = 240;

		static void Main(string[] args)
		{
			foreach (string file in Directory.GetFiles(@"D:\CD\HARRY_POTTER\POTTER", "STORY*.IMG"))
				using (Bitmap bmp = new Bitmap(width, height, PixelFormat.Format8bppIndexed))
				using (FileStream str = File.OpenRead(file))
				using (BinaryReader br = new BinaryReader(str))
				{
					ColorPalette pal = bmp.Palette;
					for (int i = 0; i < 256; i++)
					{
						ushort s = br.ReadUInt16();
						int B = (s >> 10) & 0x1F;
						B = B << 3 | B >> 2;
						int G = (s >> 5) & 0x1F;
						G = G << 3 | G >> 2;
						int R = s & 0x1F;
						R = R << 3 | R >> 2;
						pal.Entries[i] = Color.FromArgb(R, G, B);
					}
					bmp.Palette = pal;
					BitmapData bmpd = bmp.LockBits(new Rectangle(0, 0, width, height), ImageLockMode.WriteOnly, PixelFormat.Format8bppIndexed);
					Marshal.Copy(br.ReadBytes(width * height), 0, bmpd.Scan0, width * height);
					bmp.UnlockBits(bmpd);
					bmp.Save(Path.ChangeExtension(file, "PNG"));
				}
		}
	}
}
