﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace PotterText
{
	static class Program
	{
		static void Main(string[] args)
		{
			string filename;
			if (args.Length > 0)
				filename = args[0];
			else
			{
				Console.Write("File: ");
				filename = Console.ReadLine();
			}
			using (FileStream inp = File.OpenRead(filename))
			using (BinaryReader br = new BinaryReader(inp))
			using (StreamWriter writer = File.CreateText(Path.ChangeExtension(filename, "txt")))
			{
				br.ReadInt32();
				while (inp.Position < inp.Length)
				{
					char[] arr = br.ReadString(br.ReadInt32()).ToCharArray();
					for (int i = 0; i < arr.Length; i++)
						if (arr[i] >= '`' && arr[i] <= 'y')
							arr[i]++;
					writer.WriteLine(arr);
				}
			}
		}

		/// <summary>
		/// Reads a null-terminated ASCII string from the current stream and advances the position by <paramref name="length"/> bytes.
		/// </summary>
		/// <param name="length">The maximum length of the string, in bytes.</param>
		public static string ReadString(this BinaryReader br, int length)
		{
			byte[] buffer = br.ReadBytes(length);
			for (int i = 0; i < length; i += 2)
				if (BitConverter.ToInt16(buffer, i) == 0)
					return Encoding.Unicode.GetString(buffer, 0, i);
			return Encoding.Unicode.GetString(buffer);
		}
	}
}
