﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace PotterWADText
{
	static class Program
	{
		const uint XSPL = 0x4C505358;

		static void Main(string[] args)
		{
			string filename;
			if (args.Length > 0)
				filename = args[0];
			else
			{
				Console.Write("File: ");
				filename = Console.ReadLine();
			}
			using (FileStream inp = File.OpenRead(filename))
			using (BinaryReader br = new BinaryReader(inp))
			using (StreamWriter writer = File.CreateText(Path.ChangeExtension(filename, "txt")))
			{
				br.ReadInt32();
				while (br.ReadUInt32() != XSPL)
					inp.Seek(br.ReadUInt32(), SeekOrigin.Current);
				br.ReadUInt32();
				br.ReadUInt32();
				uint cnt = br.ReadUInt32() * 4;
				br.ReadUInt32();
				uint[] offsets = new uint[cnt];
				for (uint i = 0; i < cnt; i++)
					offsets[i] = br.ReadUInt32();
				long txtoff = inp.Position;
				for (uint i = 0; i < cnt; i++)
				{
					inp.Seek(txtoff + offsets[i], SeekOrigin.Begin);
					char[] arr = br.ReadString2().ToCharArray();
					for (int j = 0; j < arr.Length; j++)
						if (arr[j] >= '`' && arr[j] <= 'y')
							arr[j]++;
					writer.WriteLine(arr);
				}
			}
		}

		/// <summary>
		/// Reads a null-terminated ASCII string from the current stream and advances the position by <paramref name="length"/> bytes.
		/// </summary>
		/// <param name="length">The maximum length of the string, in bytes.</param>
		public static string ReadString2(this BinaryReader br)
		{
			StringBuilder sb = new StringBuilder();
			ushort s = br.ReadUInt16();
			while (s != 0)
			{
				sb.Append((char)s);
				s = br.ReadUInt16();
			}
			return sb.ToString();
		}
	}
}
